<template>
  <frame :modal="modal">
    <div :class="`pt-4 pb-4`">
      <div
        v-for="workspace of workspaces"
        :key="workspace.id || 'null'"
        @click="click(workspace)"
        class="rounded-lg px-6 py-2 flex flex-row items-center justify-start cursor-pointer select-none text-black"
        :class="value && value.id == workspace.id ? `font-black` : 'font-light'"
      >
        <workspaces-icon
          :class="{ 'opacity-50': !value || workspace.id != value.id }"
          :workspace="workspace"
        ></workspaces-icon>
        <div class="ml-4">
          {{ workspace.name }}
        </div>
      </div>
    </div>
  </frame>
</template>

<script lang="ts">
import { isModal, ModalComponents } from "@/use/modal";
import Workspace from "@/models/Workspace";
import { computed } from "vue";

import WorkspacesIcon from "@/components/Workspaces/Icon.vue";

export default {
  mixins: [isModal()],
  components: { ...ModalComponents, WorkspacesIcon },
  emits: ["input", "hide"],
  props: {
    value: {
      type: Workspace,
      required: false
    }
  },
  setup(props: { value?: Workspace }, context) {
    return {
      workspaces: computed(() => [Workspace.inbox, ...Workspace.query().getSync()]),
      click: (workspace: Workspace) => {
        context.emit("input", workspace);
        props.modal.hide();
      }
    };
  }
};
</script>
